/*
 Copyright:      Hagen Reddmann  mailto HaReddmann at T-Online dot de
 Author:         Hagen Reddmann
 Remarks:        this Copyright must be included
 known Problems: none
 Version:        2.1. 2004
 Description:    Graphic Library for Nokia 6100 Display and compatible
*/

.nolist
#include "glcd.inc"
#include "regs.inc"
.list

        .text

        .global glcdDoGetColor
glcdDoGetColor:                         // -> ZL=D0 colorindex, <- ZH:ZL=D1:D0 color of glcd_Colors
#ifdef USE_HIGHCOLOR
        clr     ZH                      // compare color with NONE at end
        add     ZL, ZL
        adc     ZH, ZH
        subi    ZL, lo8(-(glcd_Colors))
        sbci    ZH, hi8(-(glcd_Colors))
        ld      T0, Z+
        ld      ZH, Z
        mov     ZL, T0
        cpi     ZL, lo8(NONE)
        ldi     T0, hi8(NONE)
        cpc     ZH, T0
        ret
#else
        clr     ZH
        subi    ZL, lo8(-(glcd_Colors))
        sbci    ZH, hi8(-(glcd_Colors))
        ld      ZL, Z
        cpi     ZL, lo8(NONE)
        ret
#endif
.end
