/*
 Copyright:      Hagen Reddmann  mailto HaReddmann at T-Online dot de
 Author:         Hagen Reddmann
 Remarks:        this Copyright must be included
 known Problems: none
 Version:        2.1. 2004
 Description:    Graphic Library for Nokia 6100 Display and compatible
*/

.nolist
#include "glcd.inc"
#include "regs.inc"
.list

        .text
        .global glcdSetOrientation     // used T0, T1 stack 1
glcdSetOrientation:
        andi    P0, 3
        lds     T1, glcd_MemCtrl
        andi    T1, ~((1 << MEM_90) | (1 << MEM_180) | (1 << MEM_VW) | (1 << MEM_MX) | (1 << MEM_MY))
        or      P0, T1
        ldi     T1, MEM_CONTROL
        fcall   glcdDispCommand
        sbrc    P0, MEM_90
        ori     P0, (1 << MEM_VW) | (1 << MEM_MX)
        ldi     T1, (1 << MEM_MY)
        sbrs    P0, MEM_180
        ldi     T1, (1 << MEM_MX)
        eor     T1, P0
        sts     glcd_MemCtrl, T1
        fjmp    glcdDispData

.end
